## hdf-eos4 2.20v1.00

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS C CXX)

#-----------------------------------------------------------------------------
# Instructions for use : Normal Build
#
# For standard build of HDFEOS libraries,tests and tools. 
# Run cmake using the HDFEOS source tree to generate a build tree.
# Enable/Disable options according to requirements and
# set CMAKE_INSTALL_PREFIX to the required install path.
# Make install can be used to install all components for system-wide use.
#
#-----------------------------------------------------------------------------
# Instructions for use : Sub-Project Build
#
# To include HDFEOS as a sub-project within another project. 
# Set HDFEOS_EXTERNALLY_CONFIGURED to 1 in the parent project and
# supply values for the following variables...
#
# HDFEOS_EXPORTED_TARGETS :
#   Set this to the name of the targets variable which controls exports
#   If unset (because parent project does not support/use the 
#   INSTALL (EXPORT target...) syntax), then targets are not configured 
#   for export during install.
#
# HDFEOS_LIB_DEPENDENCIES :
#   If the build of HDFEOS libs is being customized, then rules for the
#   dependencies of the HDFEOS libs may be 'incomplete', add additional
#   dependencies to this variable so that external projects pick them up
#
# HDFEOS_EXTERNAL_LIB_PREFIX :
#   If the pa5rent project needs to install hdf libraries, but avoid 
#   name conflicts with system versions, then a prefix may be added
#   to ensure that the correct versions configured are used.
#
# Consider this example, it builds its own zlib
# library and tells HDFEOS to add it as a dependency - this ensures that
# any project making use of this build of HDFEOS will use the correct zlib
#
#   # Tell HDFEOS that we are manually overriding certain settings
#   SET (HDFEOS_EXTERNALLY_CONFIGURED 1)
#   # Avoid duplicating names of installed libraries
#   SET (HDFEOS_EXTERNAL_LIB_PREFIX "prj")
#   # Targets linking to the HDFEOS libs need to know their names
#   # if they are changed in the sub project, they should be here too
#   SET (HDFEOS_LIB_NAME "prjHDFEOS")
#   SET (HDFEOS_MF_LIB_NAME "prjHDFEOS_mf")
#   SET (HDFEOS_LIBRARY "${HDFEOS_LIB_NAME};${HDFEOS_MF_LIB_NAME}")
#   # Export configuration to this export variable
#   SET (HDFEOS_EXPORTED_TARGETS "project-targets")
#
#   # Setup all necessary overrides for zlib so that HDFEOS uses our
#   # internally compiled zlib rather than any other version
#   IF (HDF_ENABLE_Z_LIB_SUPPORT)
#    # We must tell the main HDFEOS library that it depends on our zlib 
#     SET (HDFEOS_LIB_DEPENDENCIES prjzlib)    
#     # Override the zlib header file
#     IF (PRJ_USE_SYSTEM_ZLIB)
#       SET (HEOS_ZLIB_HEADER "zlib.h")
#     ELSE (PRJ_USE_SYSTEM_ZLIB)
#      SET (HEOS_ZLIB_HEADER "prj_zlib.h")
#       # Set vars that FindZlib would have set if used in sub project
#       SET (ZLIB_INCLUDE_DIRS "${PRJ_ZLIB_INCLUDE_DIRS}")
#       SET (ZLIB_LIBRARIES prjzlib)
#     ENDIF (PRJ_USE_SYSTEM_ZLIB)
#  ENDIF (HDF_ENABLE_Z_LIB_SUPPORT)
#   
#   # Add the sub project
#   ADD_SUBDIRECTORY (Utilities/HDFEOS-1.2)
#   # Add the HDFEOS dirs to our include path
#   SET (HDFEOS_INCLUDE_DIR 
#       ${PROJECT_SOURCE_DIR}/Utilities/HDFEOS-1.2/src
#       ${PROJECT_BINARY_DIR}/Utilities/HDFEOS-1.2
#   )
#
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Allow Visual Studio solution directories
#-----------------------------------------------------------------------------
# Provide a way for Visual Studio Express users to turn OFF the new FOLDER
# organization feature. Default to ON for non-Express users. Express users must
# explicitly turn off this option to build HDFEOS in the Express IDE...
#
OPTION (HDFEOS_USE_FOLDERS "Enable folder grouping of projects in IDEs." ON)
MARK_AS_ADVANCED (HDFEOS_USE_FOLDERS)
IF (HDFEOS_USE_FOLDERS)
  SET_PROPERTY (GLOBAL PROPERTY USE_FOLDERS ON)
ENDIF (HDFEOS_USE_FOLDERS)
OPTION (HDFEOS_NO_PACKAGES "CPACK - Disable packaging" OFF)
MARK_AS_ADVANCED (HDFEOS_NO_PACKAGES)

#-----------------------------------------------------------------------------
# Set the core names of all the libraries
#-----------------------------------------------------------------------------
SET (HDFEOS_GCTP_SRC_LIB_CORENAME     "Gctp")
SET (HDFEOS_SRC_LIB_CORENAME          "hdfeos")

#-----------------------------------------------------------------------------
# Set the true names of all the libraries if customized by external project
#-----------------------------------------------------------------------------
SET (HDFEOS_GCTP_SRC_LIB_NAME     "${HDFEOS_EXTERNAL_LIB_PREFIX}${HDFEOS_GCTP_SRC_LIB_CORENAME}")
SET (HDFEOS_SRC_LIB_NAME          "${HDFEOS_EXTERNAL_LIB_PREFIX}${HDFEOS_SRC_LIB_CORENAME}")

#-----------------------------------------------------------------------------
# Set the target names of all the libraries
#-----------------------------------------------------------------------------
SET (HDFEOS_GCTP_SRC_LIB_TARGET     ${HDFEOS_GCTP_SRC_LIB_NAME})
SET (HDFEOS_SRC_LIB_TARGET          ${HDFEOS_SRC_LIB_NAME})

#-----------------------------------------------------------------------------
# Define some CMake variables for use later in the project
#-----------------------------------------------------------------------------
SET (EOS_RESOURCES_DIR          ${HDFEOS_SOURCE_DIR}/config/cmake)
SET (HDFEOS_GCTP_SRC_DIR        ${HDFEOS_SOURCE_DIR}/gctp/src)
SET (HDFEOS_GCTP_INC_DIR        ${HDFEOS_SOURCE_DIR}/gctp/include)
SET (HDFEOS_SRC_DIR             ${HDFEOS_SOURCE_DIR}/src)
SET (HDFEOS_INC_DIR             ${HDFEOS_SOURCE_DIR}/include)
SET (HDFEOS_SAMPLES_SRC_DIR     ${HDFEOS_SOURCE_DIR}/samples)

IF (NOT HDFEOS_INSTALL_BIN_DIR)
  SET (HDFEOS_INSTALL_BIN_DIR bin)
ENDIF (NOT HDFEOS_INSTALL_BIN_DIR)
IF (NOT HDFEOS_INSTALL_LIB_DIR)
  SET (HDFEOS_INSTALL_LIB_DIR lib)
ENDIF (NOT HDFEOS_INSTALL_LIB_DIR)
IF (NOT HDFEOS_INSTALL_INCLUDE_DIR)
  SET (HDFEOS_INSTALL_INCLUDE_DIR include)
ENDIF (NOT HDFEOS_INSTALL_INCLUDE_DIR)
IF (NOT HDFEOS_INSTALL_DATA_DIR)
  IF (NOT WIN32)
    SET (HDFEOS_INSTALL_DATA_DIR share)
    SET (HDFEOS_INSTALL_CMAKE_DIR share/cmake)
  ELSE (NOT WIN32)
    SET (HDFEOS_INSTALL_DATA_DIR ".")
    SET (HDFEOS_INSTALL_CMAKE_DIR cmake)
  ENDIF (NOT WIN32)
ENDIF (NOT HDFEOS_INSTALL_DATA_DIR)

#-----------------------------------------------------------------------------
# parse the full version number
#-----------------------------------------------------------------------------
FILE (READ ${HDFEOS_SRC_DIR}/EHapi.c _ehapi_c_contents)
STRING (REGEX REPLACE ".*#define[ \t]+HDFEOSVERSION1[ \t]+\"([0-9]*.[0-9]*)\".*"
    "\\1" HDFEOS_FULL_VERSION ${_ehapi_c_contents})
STRING (REGEX REPLACE ".*#define[ \t]+HDFEOSVERSION1[ \t]+\"([0-9]*).*$"
    "\\1" HDFEOS_VERS_MAJOR ${_ehapi_c_contents})
STRING (REGEX REPLACE ".*#define[ \t]+HDFEOSVERSION1[ \t]+\"[0-9]*.([0-9]*).*$"
    "\\1" HDFEOS_VERS_MINOR ${_ehapi_c_contents})
MESSAGE (STATUS "VERSION: ${HDFEOS_VERSION}")
#SET (HDFEOS_VERS_MAJOR 1)
#SET (HDFEOS_VERS_MINOR 0)
SET (HDFEOS_VERS_RELEASE 0)
#MESSAGE (STATUS "VERSION: ${HDFEOS_VERSION}")

#-----------------------------------------------------------------------------
# Basic HDFEOS stuff here
#-----------------------------------------------------------------------------
SET (HDFEOS_PACKAGE "hdf-eos2")
SET (HDFEOS_PACKAGE_NAME "hdf-eos2")
SET (HDFEOS_PACKAGE_VERSION "${HDFEOS_VERS_MAJOR}.${HDFEOS_VERS_MINOR}.${HDFEOS_VERS_RELEASE}")
SET (HDFEOS_PACKAGE_VERSION_MAJOR "${HDFEOS_VERS_MAJOR}.${HDFEOS_VERS_MINOR}")
SET (HDFEOS_PACKAGE_VERSION_MINOR "${HDFEOS_VERS_RELEASE}")
SET (HDFEOS_PACKAGE_STRING "${HDFEOS_PACKAGE_NAME} ${HDFEOS_PACKAGE_VERSION}")
SET (HDFEOS_PACKAGE_TARNAME "hdf-eos2")
SET (HDFEOS_PACKAGE_URL "http://www.hdfgroup.org")
SET (HDFEOS_PACKAGE_BUGREPORT "help@hdfgroup.org")

#-----------------------------------------------------------------------------
# Include some macros for reusable code
#-----------------------------------------------------------------------------
INCLUDE (${EOS_RESOURCES_DIR}/EOSMacros.cmake)
INCLUDE (${EOS_RESOURCES_DIR}/HDFEOSMacros.cmake)
INCLUDE (${EOS_RESOURCES_DIR}/HDF4Macros.cmake)

#-----------------------------------------------------------------------------
# Setup output Directories
#-----------------------------------------------------------------------------
IF (NOT HDFEOS_EXTERNALLY_CONFIGURED)
  SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Executables."
  )
  SET (CMAKE_LIBRARY_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Libraries"
  )
  SET (CMAKE_ARCHIVE_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all static libraries."
  )
ELSE (NOT HDFEOS_EXTERNALLY_CONFIGURED)
  # if we are externally configured, but the project uses old cmake scripts
  # this may not be set and utilities like Hdetect will fail
  IF (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})
  ENDIF (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
ENDIF (NOT HDFEOS_EXTERNALLY_CONFIGURED)

#-----------------------------------------------------------------------------
# Targets built within this project are exported at Install time for use
# by other projects using FindEOS.
#-----------------------------------------------------------------------------
IF (NOT HDFEOS_EXPORTED_TARGETS)
  SET (HDFEOS_EXPORTED_TARGETS "hdfeos-targets")
ENDIF (NOT HDFEOS_EXPORTED_TARGETS)

#-----------------------------------------------------------------------------
# To include a library in the list exported by the project AT BUILD TIME,
# add it to this variable. This is NOT used by Make Install, but for projects
# which include HDFEOS as a sub-project within their build tree
#-----------------------------------------------------------------------------
SET_GLOBAL_VARIABLE (HDFEOS_LIBRARIES_TO_EXPORT "")
SET_GLOBAL_VARIABLE (HDFEOS_APPS_TO_EXPORT "")
SET (EXTERNAL_HEADER_LIST "")
SET (EXTERNAL_LIBRARY_LIST "")
SET (EXTERNAL_LIBRARYDLL_LIST "")

#-----------------------------------------------------------------------------
# Run all the CMake configuration tests for our build environment
#-----------------------------------------------------------------------------
INCLUDE (${EOS_RESOURCES_DIR}/ConfigureChecks.cmake)

#-----------------------------------------------------------------------------
# Option to use legacy naming for windows libs/programs, default is legacy
#-----------------------------------------------------------------------------
IF (WIN32 AND NOT CYGWIN)
  OPTION (HDFEOS_LEGACY_NAMING "Use Legacy Names for Libraries and Programs" ON)
ENDIF (WIN32 AND NOT CYGWIN)

#-----------------------------------------------------------------------------
# Option to Build Shared/Static libs, default is static
#-----------------------------------------------------------------------------
OPTION (BUILD_SHARED_LIBS "Build Shared Libraries" OFF)
SET (LIB_TYPE STATIC)
IF (BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
  SET (HDFEOS_BUILT_AS_DYNAMIC_LIB 1)
  ADD_DEFINITIONS (-DHDFEOS_BUILT_AS_DYNAMIC_LIB)
  ADD_DEFINITIONS (-DH4_BUILT_AS_DYNAMIC_LIB)
ELSE (BUILD_SHARED_LIBS)
  SET (HDFEOS_BUILT_AS_STATIC_LIB 1)
  ADD_DEFINITIONS (-DHDFEOS_BUILT_AS_STATIC_LIB)
  ADD_DEFINITIONS (-DH4_BUILT_AS_STATIC_LIB)
  IF (NOT WIN32)
    # should this be a user setting : Everyone uses it anyway ?
    ADD_DEFINITIONS (-DPIC)
  ENDIF (NOT WIN32)
ENDIF (BUILD_SHARED_LIBS)

IF (NOT USE_SHARED_LIBS)
  SET (HDFEOS_USE_STATIC_LIBRARIES 1)
ENDIF (NOT USE_SHARED_LIBS)

ADD_DEFINITIONS (-DBIG_LONGS -DSWAP)
ADD_DEFINITIONS (-DHAVE_CONFIG_H)
IF (MSVC)
  ADD_DEFINITIONS (-DVISUAL_CPLUSPLUS)
ENDIF (MSVC)
IF (EOS_HAVE_F2CFORTRAN_MACRO)
  ADD_DEFINITIONS (-Df2cFortran)
ENDIF (EOS_HAVE_F2CFORTRAN_MACRO)

=== Makefile ===
#----------------------------------------------------------------------------
# file:         makefile for HDF-EOS (for internal ECS usage only)
#
# environment:  requires environment established by the ECS .buildrc file
# 
# environment variables dependencies:
#   MAKECMD  make command to be run on make files
#   ARCH     architecture (i.e. hardware/os type)
#
#
# author:  Guru Tej S. Khalsa / Space Applications Corp.
#          Adura Adekunjo    / L3 Communications GSI
#          Abe Taaheri / Raytheon IIS
#
# history:
#       10-Nov-1997 GTSK Initital version
#       23-Oct-2003 AA   Modified for Toolkit Linux Delivery
#       02-Feb-2013 AT   Modified for Toolkit Linux64 build in clearcase
#
# notes:
#       1) This file is only for use by ECS Configuration Management (CM)
#	   personnel and software.  This file should not be distributed
#	   as part of the standard HDF-EOS delivery.
#----------------------------------------------------------------------------

# define shell to be used (use ksh so we can use the "." command)

SHELL=/bin/ksh

# define MAKE to be equivalant to $(MAKECMD)

MAKE=$(MAKECMD)

# define the location of the HDF-EOS STAGE area

HE_STAGE=/ecs/formal/STAGE/hdfeos

# define the location of the standard HDF-EOS development area

HE_HOME=/ecs/hdfeos

# define HDF base directory

HDF_BASE=/ecs/cots/hdf

# define current HDF version

CURRENT_HDF=HDF4.2.10
CURRENT_SZIP=szip-2.1

# define SDP Toolkit home directory

TK_HOME=/ecs/formal/TOOLKIT

# name of tar files for delivery
HDFEOS_SOURCE_TAR=HDF-EOS2.20v1.00.tar
HDFEOS_TESTDRIVERS_TAR=HDF-EOS2.20v1.00_TestDriver.tar

# define the default compiler optimization level
OPT_LVL=-g

# define default target

default:
	@echo "This file is for use by ECS Configuration Management processes only."

# define a target to build BOTH variations (or "flavors") of HDF-EOS
# for a given "brand" (i.e. architecture type)

full: opt debug

# define a target to build the "debug" variation (or "flavor") of HDF-EOS
# for a given "brand" (i.e. architecture type) ("debug" means the library
# will be compiled for use in a souce code debugger)

debug:
	@$(MAKE) flavor_dir FLAVOR=$@
	@export use_flavor=1; $(MAKE) $(TARGET) OPT_LVL=-g FLAVOR=$@

# define a target to build the "optimized" variation (or "flavor") of
# HDF-EOS for a given "brand" (i.e. architecture type) ("optimized" means the
# library will be optimized for execution speed by the compiler)

opt:
	@$(MAKE) flavor_dir FLAVOR=$@
	@export use_flavor=1; $(MAKE) $(TARGET) OPT_LVL=-O FLAVOR=$@

# define standard CM targets

# NOTE: The standard targets defined by ECS CM are:
#       BuildImake, ProductHs, ProductLibs, LastPass, Deliver
#
#       Here the above targets are shadowed by the targets:
#       BuildImake2, ProductHs2, ProductLibs2, LastPass2, Deliver2
#       respectively.  The original targets only call the target
#       HE_ENV which sets up the HDF-EOS environment and then
#       builds the shadow target.
#       For SGI 32 Falvor build or linux 12 Falvor build these targets
#       renamed to FL_......

BuildImake:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

BuildImake2:
	@echo "No Imakefile to build."

ProductHs:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

ProductHs2:
	@echo "No header files to generate or promote."
	@/bin/touch include/HE2_config.h

ProductLibs: ProductLibs32 ProductLibs64

ProductLibs32:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

ProductLibs322:
	@if [ ! -e $(HDFEOS_HOME)/lib/$(ARCH) ] ; then	\
		cd $(HDFEOS_HOME)/lib;			\
		ln -s `basename $(HDFEOS_LIB)` $(ARCH);		\
	fi
	@cd $(HDFEOS_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp


ProductLibs64:
	@$(MAKE) $(MFLAGS) HE_ENV64 TARGET=$@2

ProductLibs642:
	@if [ ! -e $(HDFEOS_HOME)/lib/$(ARCH)64 ] ; then	\
		cd $(HDFEOS_HOME)/lib;			\
		ln -s `basename $(HDFEOS_LIB)` $(ARCH)64;		\
	fi
	@cd $(HDFEOS_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp

LastPass:LastPass32 LastPass64

LastPass32:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

LastPass322:
	@if [ ! -e $(HDFEOS_HOME)/bin/$(ARCH) ] ; then	\
		cd $(HDFEOS_HOME)/bin;			\
		ln -s `basename $(HDFEOS_BIN)` $(ARCH);\
	fi
	@cd $(HDFEOS_HOME)/util; $(MAKE) $(MFLAGS) all


LastPass64:
	@$(MAKE) $(MFLAGS) HE_ENV64 TARGET=$@2

LastPass642:
	@if [ ! -e $(HDFEOS_HOME)/bin/$(ARCH)64 ] ; then	\
		cd $(HDFEOS_HOME)/bin;			\
		ln -s `basename $(HDFEOS_BIN)` $(ARCH)64;\
	fi
	@cd $(HDFEOS_HOME)/util; $(MAKE) $(MFLAGS) all

FL_BuildImake:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_BuildImake2:
	@echo "No Imakefile to build."

FL_ProductHs:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_ProductHs2:
	@echo "No header files to generate or promote."

FL_ProductLibs:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2
	@/bin/touch include/HE2_config.h

FL_ProductLibs2:
	@if [ ! -e $(HDFEOS_HOME)/lib/$(ARCH) ] ; then	\
		cd $(HDFEOS_HOME)/lib;			\
		ln -s `basename $(HDFEOS_LIB)` $(ARCH);		\
	fi
	@cd $(HDFEOS_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp

FL_LastPass:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_LastPass2:
	@if [ ! -e $(HDFEOS_HOME)/bin/$(ARCH) ] ; then	\
		cd $(HDFEOS_HOME)/bin;			\
		ln -s `basename $(HDFEOS_BIN)` $(ARCH);\
	fi
	@cd $(HDFEOS_HOME)/util; $(MAKE) $(MFLAGS) all

#	@echo "No utilites to build."



Deliver:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

Deliver2:
	tar cvfX $(HE_HOME)/install/$(HDFEOS_SOURCE_TAR) $(HE_HOME)/make_exclude_list -C /ecs ./hdfeos
	tar cvf $(HE_HOME)/install/$(HDFEOS_TESTDRIVERS_TAR) -C /ecs ./hdfeos/testdrivers

DaacDeliver:
	@if [ $(ARCH) = "sgi6n32" ] ; then				    \
		for arch in sgi6n32 sgi6 ; do			            \
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	    \
				$(MAKECMD) full TARGET=$$targ ARCH=$$arch;  \
			done;						    \
		done;							    \
	elif [ $(ARCH) = "irix65" ] ; then				    \
		for arch in sgi6n32 sgi6 ; do			            \
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	    \
				$(MAKECMD) full TARGET=$$targ ARCH=$$arch;  \
			done;						    \
		done;                                                       \
	else								    \
		for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do		    \
			$(MAKECMD) full TARGET=$$targ;			    \
		done;							    \
	fi

LinuxDaacDeliver:  
	@if [ $(ARCH) = "linux" ] ; then				    \
		for arch in linux ; do					    \
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	    \
			$(MAKECMD) full TARGET=$$targ ARCH=$$arch;	    \
		done ;							    \
		done ;							    \
	fi

# this is a special target used to establish the HDF-EOS environment

FL_HE_ENV:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;                      \
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;         \
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux; brand=$(ARCH) ;;    \
		*)       brand=$(ARCH); ;;			\
	esac;							\
	postfix=""; 						\
	opt_flag=-O;						\
	case $(FLAVOR) in					\
		*debug)						\
			opt_flag=-g;				\
			postfix=_debug;				\
		;;						\
	esac;							\
	HDFEOS_HOME=$(HE_HOME);					\
	LNX_COMP_FLAG="-m32";					\
	export LNX_COMP_FLAG;					\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/$${brand}$$postfix/hdfeos_env.ksh;	\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib;		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDFINC PGSINC SZIPINC SZIPLIB HDFLIB;	\
	$(MAKE) $(MFLAGS) $(TARGET)

HE_ENV:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;                      \
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;         \
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux; brand=$(ARCH);;     \
		*)       brand=$(ARCH); ;;			\
	esac;							\
	HDFEOS_HOME=$(HE_HOME);					\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/tmp/hdfeos_env.ksh.tmp;		\
	if [ $(ARCH) = "linux" ] ; then				\
	CC="gcc -m32";						\
	export CC;						\
	LNX_COMP_FLAG="-m32";					\
	export LNX_COMP_FLAG;					\
	fi;							\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib;		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDFINC PGSINC SZIPINC SZIPLIB HDFLIB;	\
	$(MAKE) $(MFLAGS) $(TARGET)

HE_ENV64:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;                      \
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;         \
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux64; brand=$(ARCH)64;; \
		*)       brand=$(ARCH); ;;			\
	esac;							\
	HDFEOS_HOME=$(HE_HOME);					\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/tmp/hdfeos_env.ksh.tmp;		\
	if [ $(ARCH) = "linux" ] ; then				\
	CC="gcc -fPIC";						\
	export CC;						\
	LNX_COMP_FLAG="";					\
	export LNX_COMP_FLAG;					\
	fi;							\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib;		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDFINC PGSINC SZIPINC SZIPLIB HDFLIB;	\
	$(MAKE) $(MFLAGS) $(TARGET)

flavor_dir:
	@sgi_mode=sgi32;					\
	LNX_COMP_FLAG="-m32";					\
	export LNX_COMP_FLAG;					\
	opt_flag=-O;						\
	postfix="";						\
	case $(FLAVOR) in					\
		*debug)						\
			opt_flag=-g;				\
			postfix=_debug;				\
		;;						\
	esac;							\
	case $(ARCH) in						\
		hp10)						\
			brand=hp;				\
		;;						\
		sgi6n32)					\
			brand=sgi32;				\
			sgi_mode=n32;				\
		;;						\
		irix65)                                         \
			brand=irix65;				\
			sgi_mode=65;				\
		;;						\
		sgi6)						\
			brand=sgi64;				\
			sgi_mode=64;				\
		;;						\
		sun5.5)						\
			brand=sun5;				\
		;;						\
		sun5.8)						\
			brand=sun5.8;				\
		;;						\
		*)						\
			brand=$(ARCH);				\
		;;						\
	esac;							\
	he_obj=$(HE_HOME)/obj/$${brand}$$postfix;		\
	he_lib=$(HE_HOME)/lib/$${brand}$$postfix;		\
	he_bin=$(HE_HOME)/bin/$${brand}$$postfix;		\
	tmpdir=$(HE_HOME)/bin/tmp;				\
	if [ ! -d $$he_obj ] ; then				\
		mkdir $$he_obj;					\
	fi;							\
	if [ ! -d $$he_lib ] ; then				\
		mkdir $$he_lib;					\
	fi;							\
	if [ ! -d $$he_bin ] ; then				\
		mkdir $$he_bin;					\
	fi;							\
	hdflib=$(HDF_BASE)/$${brand}/$(CURRENT_HDF)/lib;	\
	hdfinc=$(HDF_BASE)/$${brand}/$(CURRENT_HDF)/include;	\
	sziplib=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	szipinc=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	if [ ! -f $$he_bin/hdfeos_env.csh ] ; then			\
		cd $$he_bin;						\
		echo "setenv HDFEOS_HOME $(HE_HOME)" > hdfeos_env.csh;	\
		echo "setenv HDFLIB $$hdflib" >> hdfeos_env.csh;	\
		echo "setenv HDFINC $$hdfinc" >> hdfeos_env.csh;	\
		echo "setenv SZIPLIB $$sziplib" >> hdfeos_env.csh;	\
		echo "setenv SZIPINC $$szipinc" >> hdfeos_env.csh;	\
		echo "set sgi_mode=$$sgi_mode" >> hdfeos_env.csh;	\
		echo "set opt_flag=$$opt_flag" >> hdfeos_env.csh;	\
		echo "set use_flavor=1" >> hdfeos_env.csh;		\
		sed "s^LNX_CMP_FLAG^$$LNX_COMP_FLAG^" 			\
		$$tmpdir/hdfeos_env.csh.tmp >> hdfeos_env.csh;		\
	fi;								\
	if [ ! -f $$he_bin/hdfeos_env.ksh ] ; then			\
		cd $$he_bin;						\

=== gctp/Makefile ===
#-------------------------------------------------------------------------#
#                                                                         #
#  COPYRIGHT[copyright mark] 2000, Raytheon System Company, its vendors,  #
#  and suppliers.  ALL RIGHTS RESERVED.                                   #
#                                                                         #
#-------------------------------------------------------------------------#
#----------------------------------------------------------------------------
# file:		makefile for GCTP
# 	
# environment variables dependencies:
#   compiler:  CC CFHFLAGS
#  
# author:  Sbe Taaheri 
#
# history:
#	17 Sep-2002 AT Initial version
#       11 Oct-2005 AT updated for Solaris 9 and 10
#       27 Feb-2006 TR Updated for winnt98 (cygwin)
#----------------------------------------------------------------------------

# force make to use the 'sh' shell
SHELL = /bin/sh

# name of remove utility
RM= /bin/rm
RMFLAGS= -f 

all: finc select_brand dfinc

INCFILES =	\
	src/bcea.h	\
	src/cproj.h	\
	src/isin.h	\
	src/proj.h	\
	src/gctp_prototypes.h \
	src/cproj_prototypes.h

finc: $(INCFILES)

src/bcea.h: include/bcea.h
	cp $? $@

src/cproj.h: include/cproj.h
	cp $? $@

src/isin.h: include/isin.h
	cp $? $@

src/proj.h: include/proj.h
	cp $? $@

src/gctp_prototypes.h: include/gctp_prototypes.h
	cp $? $@

src/cproj_prototypes.h: include/cproj_prototypes.h
	cp $? $@

select_brand:
	@if [ $(BRAND) = "sun5" ] ; then \
		cd src; $(MAKE) -f makesol25 ; \
	elif [ $(BRAND) = "hp" ] ; then \
		cd src; $(MAKE) -f makehp ; \
	elif [ $(BRAND) = "hp11" ] ; then \
		cd src; $(MAKE) -f makehp11 ; \
	elif [ $(BRAND) = "dec" ] ; then \
		cd src; $(MAKE) -f makedec ; \
	elif [ $(BRAND) = "ibm" ] ; then \
		cd src; $(MAKE) -f makeibm ; \
	elif [ $(BRAND) = "irix65" ] ; then \
		cd src; $(MAKE) -f makesgi65_64 ; \
		$(MAKE) -f makesgi65_n32 ; \
	elif [ $(BRAND) = "linux" ] ; then \
		cd src; $(MAKE) -f makelinux ; \
	elif [ $(BRAND) = "linux32" ] ; then \
		cd src; $(MAKE) -f makelinux32 ; \
	elif [ $(BRAND) = "linux64" ] ; then \
		cd src; $(MAKE) -f makelinux64 ; \
	elif [ $(BRAND) = "sgi" ] ; then \
		cd src; $(MAKE) -f makesgi32 ; \
	elif [ $(BRAND) = "sgi32" ] ; then \
		cd src; $(MAKE) -f makesgin32 ; \
	elif [ $(BRAND) = "sgi64" ] ; then \
		cd src; $(MAKE) -f makesgi64 ; \
	elif [ $(BRAND) = "sun5.8" ] ; then \
		cd src; $(MAKE) -f makesol28 ; \
	elif [ $(BRAND) = "sun5.9" ] ; then \
		cd src; $(MAKE) -f makesol29 ; \
	elif [ $(BRAND) = "sun5.10" ] ; then \
		cd src; $(MAKE) -f makesol210 ; \
	elif [ $(BRAND) = "sun5.11" ] ; then \
		cd src; $(MAKE) -f makesol211 ; \
	elif [ $(BRAND) = "winnt98" ] ; then \
		cd src; $(MAKE) -f makecygwin ; \
	elif [ $(BRAND) = "macintosh" ] ; then \
		cd src; $(MAKE) -f makemacintosh ; \
	elif [ $(BRAND) = "macintel" ] ; then \
		cd src; $(MAKE) -f makemacintel ; \
	elif [ $(BRAND) = "macintel32" ] ; then \
		cd src; $(MAKE) -f makemacintel32 ; \
	elif [ $(BRAND) = "macintel64" ] ; then \
		cd src; $(MAKE) -f makemacintel64 ; \
	else \
		echo " The brand $(BRAND) is not supported. " ; \
		echo " Set the env. vriable BRAND to a supported one then make this makefile"; \
	fi ;

clean:
	$(RM) $(RMFLAGS) core *.o
	$(RM) $(RMFLAGS) src/*.o


dfinc:
	@$(RM) $(RMFLAGS) $(INCFILES)

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS_SRC C CXX)

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
LINK_DIRECTORIES (
    ${HDFEOS_SRC_BINARY_DIR}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
)

SET (HDFEOS_SRC_CSRCS
    ${HDFEOS_SRC_SOURCE_DIR}/EHapi.c
    ${HDFEOS_SRC_SOURCE_DIR}/GDapi.c
    ${HDFEOS_SRC_SOURCE_DIR}/PTapi.c
    ${HDFEOS_SRC_SOURCE_DIR}/SWapi.c
)

SET (HDFEOS_SRC_CHDRS
#    ${HDFEOS_INC_DIR}/HE2_config.h
    ${HDFEOS_INC_DIR}/HdfEosDef.h
    ${HDFEOS_INC_DIR}/HDFEOSVersion.h
    ${HDFEOS_INC_DIR}/cfortHdf.h
    ${HDFEOS_INC_DIR}/ease.h
)

IF (H5_USE_HDFEOS2)
  ADD_DEFINITIONS (-DHAVE_LIBHDFEOS)
ENDIF (H5_USE_HDFEOS2)

ADD_LIBRARY (${HDFEOS_SRC_LIB_TARGET} ${LIB_TYPE} ${HDFEOS_SRC_CSRCS} ${HDFEOS_SRC_CHDRS})
IF (MSVC)
  TARGET_LINK_LIBRARIES (${HDFEOS_SRC_LIB_TARGET} "ws2_32.lib")
ELSE (MSVC)
  SET_TARGET_PROPERTIES (${HDFEOS_SRC_LIB_TARGET} PROPERTIES LINK_FLAGS "-Wl,-single_module")
ENDIF (MSVC)
TARGET_LINK_LIBRARIES (${HDFEOS_SRC_LIB_TARGET} ${LINK_LIBS})
SET_GLOBAL_VARIABLE (HDFEOS_LIBRARIES_TO_EXPORT "${HDFEOS_LIBRARIES_TO_EXPORT};${HDFEOS_SRC_LIB_TARGET}")
HDFEOS_SET_LIB_OPTIONS (${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_SRC_LIB_NAME} ${LIB_TYPE})

#-----------------------------------------------------------------------------
# Add file(s) to CMake Install
#-----------------------------------------------------------------------------
IF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)
  INSTALL (
      FILES
          ${HDFEOS_SRC_CHDRS}
      DESTINATION
          ${HDFEOS_INSTALL_INCLUDE_DIR}
      COMPONENT
          headers
  )
ENDIF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFEOS_EXPORTED_TARGETS)

  INSTALL_TARGET_PDB (${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_INSTALL_LIB_DIR} libraries)
  
  INSTALL (
      TARGETS 
          ${HDFEOS_SRC_LIB_TARGET}
      EXPORT
          ${HDFEOS_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HDFEOS_INSTALL_BIN_DIR} COMPONENT libraries
  )
ENDIF (HDFEOS_EXPORTED_TARGETS)

=== src/Makefile ===
# Copyright (C) 1996 Hughes and Applied Research Corporation
#
# Permission to use, modify, and distribute this software and its
# documentation for any purpose without fee is hereby granted, provided that
# the above copyright notice appear in all copies and that both that copyright
# notice and this permission notice appear in supporting documentation.
#
# Makefile
# 
# Makefile for field build of HDFEOS
#
# The following environment variables must be defined:
#
#   Flags:
#     AR           library archiving program and flags (e.g.: ar -r)
#     CC           C language compiler (e.g.: cc)
#     CFHFLAGS     C compiler flags and cfortran.h switches
#                  (e.g.: -Xa -O -DsunFortan)
#     RANLIB       ranlib program (e.g. ranlib)
#
#   Directories:
#     HDFEOS_INC   HDF-EOS include directory ($HDFEOS_HOME/include)
#     HDFEOS_LIB   HDF-EOS library directory ($HDFEOS_HOME/lib/$BRAND)
#     HDFEOS_OBJ   HDF-EOS object directory ($HDFEOS_HOME/obj/$BRAND)

# force make program to use bourne shell
SHELL=/bin/sh

# define remove utility
RM = rm -f 

AR = ar -r

# define C preprocessor symbols. Add -DMRTlinux to following 
# line for HEG library creation. MRTlinux is used in GDapi.c and SWaoi.c
DFLAGS = -D$(HDFSYS)

# location of include files need to compile source code
IFLAGS = -I. -I$(HDFEOS_INC) -I$(SZIPINC) -I$(HDFINC)

# object files needed to build library
LIBOFILES = \
	$(HDFEOS_OBJ)/EHapi.o \
	$(HDFEOS_OBJ)/GDapi.o \
	$(HDFEOS_OBJ)/PTapi.o \
	$(HDFEOS_OBJ)/SWapi.o

# default target, this just builds the hdfeos library
all:
	@touch ../include/HE2_config.h
	@if [ "$(BRAND)" = "sun4" ] ; then				\
		$(MAKE) $(MFLAGS) $(HDFEOS_LIB)/libhdfeos.a ranlib;	\
	else								\
		$(MAKE) $(MFLAGS) $(HDFEOS_LIB)/libhdfeos.a;		\
	fi

$(HDFEOS_LIB)/libhdfeos.a: $(LIBOFILES)
	$(AR) $@ $?

ranlib:
	$(RANLIB) $(HDFEOS_LIB)/libhdfeos.a

install: 
	@echo "no binaries to move"
	@echo "don't worry"

clean:
	$(RM) *.o $(HDFEOS_OBJ)/*.o

$(HDFEOS_OBJ)/EHapi.o : EHapi.c 
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS_OBJ)/SWapi.o : SWapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS_OBJ)/GDapi.o : GDapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

$(HDFEOS_OBJ)/PTapi.o : PTapi.c
	$(CC) $(CFHFLAGS) $(DFLAGS) $(IFLAGS) -c $? -o $@

.c.o:
	$(MAKE) $(MFLAGS) $(HDFEOS_OBJ)/$@

=== testdrivers/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (TESTDRIVERS C CXX)

ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/swath      ${TESTDRIVERS_BINARY_DIR}/swath)
ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/grid       ${TESTDRIVERS_BINARY_DIR}/grid)
ADD_SUBDIRECTORY (${TESTDRIVERS_SOURCE_DIR}/point      ${TESTDRIVERS_BINARY_DIR}/point)

=== gctp/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (GCTP_SRC C CXX)

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
LINK_DIRECTORIES (
    ${GCTP_SRC_BINARY_DIR}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
)

SET (GCTP_SRC_CSRCS
    ${GCTP_SRC_SOURCE_DIR}/gctp.c
    ${GCTP_SRC_SOURCE_DIR}/alberfor.c
    ${GCTP_SRC_SOURCE_DIR}/alberinv.c
    ${GCTP_SRC_SOURCE_DIR}/alconfor.c
    ${GCTP_SRC_SOURCE_DIR}/alconinv.c
    ${GCTP_SRC_SOURCE_DIR}/azimfor.c
    ${GCTP_SRC_SOURCE_DIR}/aziminv.c
    ${GCTP_SRC_SOURCE_DIR}/bceafor.c
    ${GCTP_SRC_SOURCE_DIR}/bceainv.c
    ${GCTP_SRC_SOURCE_DIR}/br_gctp.c
    ${GCTP_SRC_SOURCE_DIR}/ceafor.c
    ${GCTP_SRC_SOURCE_DIR}/ceainv.c
    ${GCTP_SRC_SOURCE_DIR}/cproj.c
    ${GCTP_SRC_SOURCE_DIR}/eqconfor.c
    ${GCTP_SRC_SOURCE_DIR}/eqconinv.c
    ${GCTP_SRC_SOURCE_DIR}/equifor.c
    ${GCTP_SRC_SOURCE_DIR}/equiinv.c
    ${GCTP_SRC_SOURCE_DIR}/for_init.c
    ${GCTP_SRC_SOURCE_DIR}/gnomfor.c
    ${GCTP_SRC_SOURCE_DIR}/gnominv.c
    ${GCTP_SRC_SOURCE_DIR}/goodfor.c
    ${GCTP_SRC_SOURCE_DIR}/goodinv.c
    ${GCTP_SRC_SOURCE_DIR}/gvnspfor.c
    ${GCTP_SRC_SOURCE_DIR}/gvnspinv.c
    ${GCTP_SRC_SOURCE_DIR}/hamfor.c
    ${GCTP_SRC_SOURCE_DIR}/haminv.c
    ${GCTP_SRC_SOURCE_DIR}/imolwfor.c
    ${GCTP_SRC_SOURCE_DIR}/imolwinv.c
    ${GCTP_SRC_SOURCE_DIR}/inv_init.c
    ${GCTP_SRC_SOURCE_DIR}/isinusfor.c
    ${GCTP_SRC_SOURCE_DIR}/isinusinv.c
    ${GCTP_SRC_SOURCE_DIR}/lamazfor.c
    ${GCTP_SRC_SOURCE_DIR}/lamazinv.c
    ${GCTP_SRC_SOURCE_DIR}/lamccfor.c
    ${GCTP_SRC_SOURCE_DIR}/lamccinv.c
    ${GCTP_SRC_SOURCE_DIR}/merfor.c
    ${GCTP_SRC_SOURCE_DIR}/merinv.c
    ${GCTP_SRC_SOURCE_DIR}/millfor.c
    ${GCTP_SRC_SOURCE_DIR}/millinv.c
    ${GCTP_SRC_SOURCE_DIR}/molwfor.c
    ${GCTP_SRC_SOURCE_DIR}/molwinv.c
    ${GCTP_SRC_SOURCE_DIR}/obleqfor.c
    ${GCTP_SRC_SOURCE_DIR}/obleqinv.c
    ${GCTP_SRC_SOURCE_DIR}/omerfor.c
    ${GCTP_SRC_SOURCE_DIR}/omerinv.c
    ${GCTP_SRC_SOURCE_DIR}/orthfor.c
    ${GCTP_SRC_SOURCE_DIR}/orthinv.c
    ${GCTP_SRC_SOURCE_DIR}/paksz.c
    ${GCTP_SRC_SOURCE_DIR}/polyfor.c
    ${GCTP_SRC_SOURCE_DIR}/polyinv.c
    ${GCTP_SRC_SOURCE_DIR}/psfor.c
    ${GCTP_SRC_SOURCE_DIR}/psinv.c
    ${GCTP_SRC_SOURCE_DIR}/report.c
    ${GCTP_SRC_SOURCE_DIR}/robfor.c
    ${GCTP_SRC_SOURCE_DIR}/robinv.c
    ${GCTP_SRC_SOURCE_DIR}/sinfor.c
    ${GCTP_SRC_SOURCE_DIR}/sininv.c
    ${GCTP_SRC_SOURCE_DIR}/sphdz.c
    ${GCTP_SRC_SOURCE_DIR}/somfor.c
    ${GCTP_SRC_SOURCE_DIR}/sominv.c
    ${GCTP_SRC_SOURCE_DIR}/sterfor.c
    ${GCTP_SRC_SOURCE_DIR}/sterinv.c
    ${GCTP_SRC_SOURCE_DIR}/stplnfor.c
    ${GCTP_SRC_SOURCE_DIR}/stplninv.c
    ${GCTP_SRC_SOURCE_DIR}/tmfor.c
    ${GCTP_SRC_SOURCE_DIR}/tminv.c
    ${GCTP_SRC_SOURCE_DIR}/untfz.c
    ${GCTP_SRC_SOURCE_DIR}/utmfor.c
    ${GCTP_SRC_SOURCE_DIR}/utminv.c
    ${GCTP_SRC_SOURCE_DIR}/vandgfor.c
    ${GCTP_SRC_SOURCE_DIR}/vandginv.c
    ${GCTP_SRC_SOURCE_DIR}/wivfor.c
    ${GCTP_SRC_SOURCE_DIR}/wivinv.c
    ${GCTP_SRC_SOURCE_DIR}/wviifor.c
    ${GCTP_SRC_SOURCE_DIR}/wviiinv.c
)

SET (GCTP_HEADERS
    ${HDFEOS_GCTP_INC_DIR}/bcea.h
    ${HDFEOS_GCTP_INC_DIR}/cproj.h
    ${HDFEOS_GCTP_INC_DIR}/cproj_prototypes.h
    ${HDFEOS_GCTP_INC_DIR}/gctp_prototypes.h
    ${HDFEOS_GCTP_INC_DIR}/proj.h
    ${HDFEOS_GCTP_INC_DIR}/isin.h
)

ADD_LIBRARY (${HDFEOS_GCTP_SRC_LIB_TARGET} ${LIB_TYPE} ${GCTP_SRC_CSRCS} ${GCTP_HEADERS})
IF(MSVC)
  TARGET_LINK_LIBRARIES (${HDFEOS_GCTP_SRC_LIB_TARGET} "ws2_32.lib")
ENDIF(MSVC)
TARGET_LINK_LIBRARIES (${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
SET_GLOBAL_VARIABLE (HDFEOS_LIBRARIES_TO_EXPORT "${HDFEOS_LIBRARIES_TO_EXPORT};${HDFEOS_GCTP_SRC_LIB_TARGET}")
HDFEOS_SET_LIB_OPTIONS (${HDFEOS_GCTP_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_NAME} ${LIB_TYPE})

#-----------------------------------------------------------------------------
# Add file(s) to CMake Install
#-----------------------------------------------------------------------------
IF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)
  INSTALL (
      FILES
          ${GCTP_HEADERS}
      DESTINATION
          ${HDFEOS_INSTALL_INCLUDE_DIR}
      COMPONENT
          headers
  )
ENDIF (NOT HDFEOS_INSTALL_NO_DEVELOPMENT)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFEOS_EXPORTED_TARGETS)

  INSTALL_TARGET_PDB (${HDFEOS_GCTP_SRC_LIB_TARGET} ${HDFEOS_INSTALL_LIB_DIR} libraries)
  
  INSTALL (
      TARGETS 
          ${HDFEOS_GCTP_SRC_LIB_TARGET}
      EXPORT
          ${HDFEOS_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HDFEOS_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HDFEOS_INSTALL_BIN_DIR} COMPONENT libraries
  )
ENDIF (HDFEOS_EXPORTED_TARGETS)

=== testdrivers/grid/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS_TESTDRIVERS_GRID)

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
LINK_DIRECTORIES (
    ${HDFEOS_SRC_BINARY_DIR}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
)

ADD_EXECUTABLE (testgrid ${PROJECT_SOURCE_DIR}/testgrid.c)
TARGET_NAMING (testgrid ${LIB_TYPE})
TARGET_LINK_LIBRARIES (testgrid ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")

  IF (HDF5_ENABLE_SZIP_SUPPORT)
    SET (fort_testdriver_src testgrid_szip77)
  ELSE (HDF5_ENABLE_SZIP_SUPPORT)
    SET (fort_testdriver_src testgrid77)
  ENDIF (HDF5_ENABLE_SZIP_SUPPORT)

  ADD_EXECUTABLE (testgrid_f77 ${PROJECT_SOURCE_DIR}/${fort_testdriver_src}.f)
  TARGET_NAMING (testgrid_f77 ${LIB_TYPE})
  TARGET_FORTRAN_WIN_PROPERTIES (testgrid_f77 "")
  SET_TARGET_PROPERTIES (testgrid_f77 PROPERTIES LINKER_LANGUAGE Fortran)
  TARGET_LINK_LIBRARIES (testgrid_f77 ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

  IF (HAVE_F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testgrid_f90 ${PROJECT_SOURCE_DIR}/testgridf90-32.f)
    TARGET_NAMING (testgrid_f90 ${LIB_TYPE})
    TARGET_FORTRAN_WIN_PROPERTIES (testgrid_f90 "")
    SET_TARGET_PROPERTIES (testgrid_f90 PROPERTIES LINKER_LANGUAGE Fortran)
    TARGET_LINK_LIBRARIES (testgrid_f90 ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
  ENDIF (HAVE_F2CFORTRAN_32PTR)
ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)

  ADD_TEST (NAME GRID_test_c COMMAND $<TARGET_FILE:testgrid>)

  ADD_TEST (NAME GRID_test_c_verbose COMMAND $<TARGET_FILE:testgrid> -v h)
  SET_TESTS_PROPERTIES (GRID_test_c_verbose PROPERTIES DEPENDS GRID_test_c)

  IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
    # Remove any output file left over from previous test run
    ADD_TEST (
        NAME GRID_test_f77-clearall-objects
        COMMAND    ${CMAKE_COMMAND} -E remove
            Grid3.hdf Gridc_Test.hdf Gridf_Test.hdf testgridf.txt
    )
    SET_TESTS_PROPERTIES (GRID_test_f77-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (GRID_test_f77-clearall-objects PROPERTIES DEPENDS GRID_test_c_verbose)

    ADD_TEST (NAME GRID_test_f77 COMMAND $<TARGET_FILE:testgrid_f77>)
    SET_TESTS_PROPERTIES (GRID_test_f77 PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (GRID_test_f77 PROPERTIES DEPENDS GRID_test_f77-clearall-objects)

    IF (HAVE_F2CFORTRAN_32PTR)
      # Remove any output file left over from previous test run
      ADD_TEST (
          NAME GRID_test_f90-clearall-objects
          COMMAND    ${CMAKE_COMMAND} -E remove
              Grid3.hdf Gridc_Test.hdf Gridf_Test.hdf testgridf.txt
      )
      SET_TESTS_PROPERTIES (GRID_test_f90-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
      SET_TESTS_PROPERTIES (GRID_test_f90-clearall-objects PROPERTIES DEPENDS GRID_test_f77)

      ADD_TEST (NAME GRID_test_f90 COMMAND $<TARGET_FILE:testgrid_f90>)
      SET_TESTS_PROPERTIES (GRID_test_f90 PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
      SET_TESTS_PROPERTIES (GRID_test_f90 PROPERTIES DEPENDS GRID_test_f90-clearall-objects)
    ENDIF (HAVE_F2CFORTRAN_32PTR)
  ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)

ENDIF (BUILD_TESTING)

=== testdrivers/swath/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS_TESTDRIVERS_SWATH)

#-----------------------------------------------------------------------------
# Setup include Directories
#-----------------------------------------------------------------------------
LINK_DIRECTORIES (
    ${HDFEOS_SRC_BINARY_DIR}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
)

ADD_EXECUTABLE (testswath ${PROJECT_SOURCE_DIR}/testswath.c)
TARGET_NAMING (testswath ${LIB_TYPE})
TARGET_LINK_LIBRARIES (testswath ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")

  ADD_EXECUTABLE (testswath_f77 ${PROJECT_SOURCE_DIR}/testswath.f)
  TARGET_NAMING (testswath_f77 ${LIB_TYPE})
  TARGET_FORTRAN_WIN_PROPERTIES (testswath_f77 "")
  SET_TARGET_PROPERTIES (testswath_f77 PROPERTIES LINKER_LANGUAGE Fortran)
  TARGET_LINK_LIBRARIES (testswath_f77 ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

  IF (HAVE_F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testswath_f90 ${PROJECT_SOURCE_DIR}/testswathf90-32.f)
    TARGET_NAMING (testswath_f90 ${LIB_TYPE})
    TARGET_FORTRAN_WIN_PROPERTIES (testswath_f90 "")
    SET_TARGET_PROPERTIES (testswath_f90 PROPERTIES LINKER_LANGUAGE Fortran)
    TARGET_LINK_LIBRARIES (testswath_f90 ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
  ENDIF (HAVE_F2CFORTRAN_32PTR)
ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)

  ADD_TEST (NAME SWATH_test_c COMMAND $<TARGET_FILE:testswath>)

  ADD_TEST (NAME SWATH_test_c_verbose COMMAND $<TARGET_FILE:testswath> -v h)
  SET_TESTS_PROPERTIES (SWATH_test_c_verbose PROPERTIES DEPENDS SWATH_test_c)

  IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
    # Remove any output file left over from previous test run
    ADD_TEST (
        NAME SWATH_test_f77-clearall-objects
        COMMAND    ${CMAKE_COMMAND} -E remove
            Swath_2.hdf Swathc_Test.hdf Swathf_Test.hdf testswathf.txt
    )
    SET_TESTS_PROPERTIES (SWATH_test_f77-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (SWATH_test_f77-clearall-objects PROPERTIES DEPENDS SWATH_test_c_verbose)

    ADD_TEST (NAME SWATH_test_f77 COMMAND $<TARGET_FILE:testswath_f77>)
    SET_TESTS_PROPERTIES (SWATH_test_f77 PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (SWATH_test_f77 PROPERTIES DEPENDS SWATH_test_f77-clearall-objects)

    IF (HAVE_F2CFORTRAN_32PTR)
      # Remove any output file left over from previous test run
      ADD_TEST (
          NAME SWATH_test_f90-clearall-objects
          COMMAND    ${CMAKE_COMMAND} -E remove
              Swath_2.hdf Swathc_Test.hdf Swathf_Test.hdf testswathf.txt
      )
      SET_TESTS_PROPERTIES (SWATH_test_f90-clearall-objects PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
      SET_TESTS_PROPERTIES (SWATH_test_f90-clearall-objects PROPERTIES DEPENDS SWATH_test_f77)

      ADD_TEST (NAME SWATH_test_f90 COMMAND $<TARGET_FILE:testswath_f90>)
      SET_TESTS_PROPERTIES (SWATH_test_f90 PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
      SET_TESTS_PROPERTIES (SWATH_test_f90 PROPERTIES DEPENDS SWATH_test_f90-clearall-objects)
    ENDIF (HAVE_F2CFORTRAN_32PTR)
  ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)

ENDIF (BUILD_TESTING)

=== debian/changelog ===
hdf-eos4 (2.20v1.00-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:23:35 +0000

hdf-eos4 (2.20v1.00-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064091

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:25:00 +0000

hdf-eos4 (2.20v1.00-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.4
  * Add salsa.d.o. as VCS
  * Drop hdf4_l patch as merged
  * Mark libhdfes0, libhdfeos-dev as Multi-Arch: same

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 31 May 2018 14:09:40 +0100

=== debian/control ===
Source: hdf-eos4
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Standards-Version: 4.1.4
Homepage: http://www.hdfeos.org
Vcs-Browser: https://salsa.debian.org:/science-team/hdf-eos4.git
Vcs-Git: https://salsa.debian.org:/science-team/hdf-eos4.git
Build-Depends: dpkg-dev (>= 1.22.5), debhelper  (>= 10),
 dh-buildinfo,
 gfortran,
 libhdf4-alt-dev,
 libjpeg-dev,
 libgctp-dev,
 zlib1g-dev

Package: libhdfeos0t64
Provides: ${t64:Provides}
Replaces: libhdfeos0
Breaks: libhdfeos0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Earth Observation System extensions to HDF4
 HDF-EOS4 is a software library designed built on HDF4 to support EOS-specific
 data structures, namely Grid, Point, and Swath. The new data structures 
 are constructed from standard HDF data objects, using EOS conventions, through
 the use of a software library [1,4]. A key feature of HDF-EOS files is that
 instrument-independent services, such as subsetting by geolocation, can be
 applied to the files across a wide variety of data products. 
 The library is extensible and new data structures can be added.

Package: libhdfeos-dev
Architecture: any
Section: libdevel
Depends: libhdfeos0t64 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Recommends: pkg-config
Description:  Development files for the HDF-EOS4 library
 HDF-EOS4 is a software library designed built on HDF4 to support EOS-specific
 data structures, namely Grid, Point, and Swath. The new data structures 
 are constructed from standard HDF data objects, using EOS conventions, through
 the use of a software library [1,4]. A key feature of HDF-EOS files is that
 instrument-independent services, such as subsetting by geolocation, can be
 applied to the files across a wide variety of data products. 
 .
 This package contains include files and static libraries for HDF-EOS4.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
BUILDDIR:=$(shell pwd)
AUTOGENERATED:= libhdfeos-dev.install

CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)

# Set SHELL in examples/ makefiles to /bin/sh
export CONFIG_SHELL=/bin/sh

# Magic debhelper rule
%:
	dh   $@ 

override_dh_auto_clean:
	find . -type l -delete
	rm -f libtool config.status config.log samples/*.hdf testdrivers/*/*.hdf
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_test:
	@echo "Tests disabled"

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure -- --enable-shared --with-pic \
		CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS) -Df2cFortran -I/usr/include/hdf"
	# FIXME: a sort of hack
	ln -sf testswath.f testdrivers/swath/testswath77.f
	ln -sf testpoint.f testdrivers/point/testpoint77.f

override_dh_auto_install:
	dh_auto_install
	# Undo permissions we don't want
	$(MAKE) -C samples clean
	chmod -x samples/*
	# Lose the builddir for reproducibility
	sed -e 's%${BUILDDIR}%/nonexistant%' < samples/Makefile > x
	mv x samples/Makefile
	# Symlinks
	dh_link -p libhdfeos0t64 $(LIBDIR)/libhdfeos.so.0.0.0  $(LIBDIR)/libhdfeos.so.0
	dh_link -p libhdfeos-dev $(LIBDIR)/libhdfeos.so.0.0.0 $(LIBDIR)/libhdfeos.so
